[wait time=200]
[loadplugin module="gamepad.dll"]
*start|X^[g
[cm]
[position layer="message1" page="fore" visible="false"]
[position layer="message1" page="back" visible="false"]
[position layer="message0" page="fore" visible="false"]
[position layer="message0" page="back" visible="false"]

[iscript]
System.setArgument("-contfreq", 60);

kag.gamepadport = new GamepadPort();
kag.gamepadport.initialize( kag.HWND );
if( kag.gamepadport.count > 0 ) {
	kag.gamepad0 = kag.gamepadport.getController(0);
	dm( kag.gamepad0.name );
	kag.gamepad0.update();
} else {
	kag.gamepad0 = void;
}
if( kag.gamepadport.count > 1 ) {
	kag.gamepad1 = kag.gamepadport.getController(1);
	dm( kag.gamepad1.name );
	kag.gamepad1.update();
} else {
	kag.gamepad1 = void;
}

class gamePadHandler
{
	var		moving = false; // ^C}[nĂ邩ǂ
	var		lastTick;
	var		move_pos_x;
	var		move_pos_y;
	var		move_pos_x1;
	var		move_pos_y1;

	function gamePadHandler() {
		this.moving = false;
		this.move_pos_x = 0;
		this.move_pos_y = 0;
		this.move_pos_x1 = 0;
		this.move_pos_y1 = 0;
	}

	function finalize() { stop(); }

	function start() {
		if(moving==false) {
			lastTick = System.getTickCount();
			System.addContinuousHandler(handler); // ContinuousHandlers ɒǉ
			moving = true;
		}
	}

	function stop() {
		if(moving) {
			System.removeContinuousHandler(handler);
			moving = false;
		}
	}

	function handler(tick) {
		var		interval = tick - lastTick;
		if( interval > 16 ) {
			if( kag.gamepad0 !== void ) {
				kag.gamepad0.update();

				move_pos_x += (int)( kag.gamepad0.leftThumbStickX * 5 );
				move_pos_y -= (int)( kag.gamepad0.leftThumbStickY * 5 );

				kag.fore.layers[0].left = move_pos_x;
				kag.fore.layers[0].top = move_pos_y;
			}
			if( kag.gamepad1 !== void ) {
				kag.gamepad1.update();

				this.move_pos_x1 += (int)( kag.gamepad1.leftThumbStickX * 5 );
				this.move_pos_y1 -= (int)( kag.gamepad1.leftThumbStickY * 5 );

				kag.fore.layers[1].left = move_pos_x1;
				kag.fore.layers[1].top = move_pos_y1;
			}
			lastTick = tick;
		}
	}
}

kag.padHandler = new gamePadHandler();
kag.add( kag.padHandler );
kag.padHandler.start();
[endscript]

[image storage=seara01 layer=0 page=fore visible=true left=0 top=0]
[image storage=seara01 layer=1 page=fore visible=true left=0 top=0]

[s]

